// **********************************************
// In Memory Database Initialization
// Project : PRJ Handling Debug
// **********************************************
using System;
using System.Reflection;
using com.progamma;
using com.progamma.ids;

// **********************************************
// In Memory Database Initialization
// **********************************************
[Serializable]
public sealed class MyImdbInit : ImdbInit
{
  public static int IMDB_OFFSET = 0;

  // **********************************************
  // Costruttore
  // **********************************************
  public MyImdbInit(WebEntryPoint p)
    : base(p)
  {
    //
    IMDB.set_DBSize(1 + MyImdbInit.IMDB_OFFSET);
    //
    //
    //
    //
    IMDB.set_TblNumField(IMDBDef1.TMP_RECORDSET, 0);
    IMDB.set_Version(0);
    //
    // Set all tables in a modified state
    //
    IMDB.ResetAllModified(-1);
  }

  // ********************************************************
  // Appende tutte le mie tabelle nell'IMDB di ownobj
  // ********************************************************
  public override void AppendTo(Object Dst)
  {
    IMDBObj dstIMDB = null;
    if (Dst is com.progamma.ids.ImdbInit)
      dstIMDB = ((com.progamma.ids.ImdbInit)Dst).IMDB;
    if (Dst is com.progamma.svc.ImdbInit)
      dstIMDB = ((com.progamma.svc.ImdbInit)Dst).IMDB;
    if (Dst is com.progamma.ws.ImdbInit)
      dstIMDB = ((com.progamma.ws.ImdbInit)Dst).IMDB;
    //
    // Per cominciare appendo tutte le tabelle contenute in iobj dentro alle mie tabelle
    int ownSize = dstIMDB.DBSize();
    //
    dstIMDB.AppendTables(IMDB, MyImdbInit.IMDB_OFFSET);
    //
    // Se non l'ho ancora fatto shifto tutte le costanti contenute in IMDBDefXX
    if (MyImdbInit.IMDB_OFFSET == 0)
    {
      MyImdbInit.IMDB_OFFSET = ownSize;
      //
      String tn = (MainFrm.CompNameSpace != null ? MainFrm.CompNameSpace + "." : "");
      for (int i = 1; i < 1000; i++)
      {
        Type T = Assembly.GetExecutingAssembly().GetType(tn + "IMDBDef" + i);
        if (T == null)
          break;
        //
        FieldInfo[] props = T.GetFields();
        for (int j = 0; j < props.Length; j++)
        {
          FieldInfo p = props[j];
          if (p.Name.StartsWith("PQRY_") || p.Name.StartsWith("QRY_") || p.Name.StartsWith("TBL_") || p.Name.Equals("TMP_RECORDSET"))
            p.SetValue(null, ((int)p.GetValue(null)) + MyImdbInit.IMDB_OFFSET);
        }
      }
    }
    //
    // Ora uso quello
    IMDB = dstIMDB;
  }
  
  // IMDB DDL Procedures
}
